<template>
	<div>
		<!-- 奖扣ab分弹窗 -->
		<el-dialog :title="title" :visible.sync="visible" :close-on-click-modal="false" :before-close="closePopup" width="600px">
			<div>
				<el-form :model="dialogData" ref="dialogData" label-width="80px" v-loading="loading">
					<el-form-item label="录入对象" prop="members" :rules="[{ required: true, message: '请选择录入对象', trigger: 'change' }]">
						<el-row>
							<el-col :span="18">
								<el-input auto-complete="off" v-model="employeeName" placeholder="请选择录入对象"></el-input>
								<div
									v-if="employee_list.length > 0"
									@click="show_employee_selector = true"
									style=" position: absolute; top: 0; right: 0; left: 0; bottom: 0; z-index: 9;"
								></div>
								<div
									v-if="employee_list.length == 0"
									@click="noPersonnelListTips"
									style=" position: absolute; top: 0; right: 0; left: 0; bottom: 0; z-index: 9;"
								></div>
							</el-col>
						</el-row>
						<EmployeeSelector
							:employee_not_select="employee_not_select"
							:employee_list="employee_list"
							:can_select_employee="true"
							:can_select_dept="false"
							:close_clear_data="false"
							:selected="employee_selected"
							:visible.sync="show_employee_selector"
							@confirm="move_employee_confirm"
						/>
					</el-form-item>

					<div v-for="(item, index) in dialogData.items" :key="index" @click.stop="itemIndex = index">
						<div style="overflow: hidden;">
							<span style="line-height: 36px;">录入明细({{ index + 1 }})</span>
							<el-button type="text" class="fr" v-show="index > 0 || dialogData.items.length > 1" @click="delItem(index)">删除</el-button>
						</div>

						<el-form-item label="指定规则">
							<el-switch @change="switchChange(index, item.rule_switch)" v-model="item.rule_switch" active-color="#13ce66"></el-switch>
						</el-form-item>

						<el-form-item
							class="test_cascader_id"
							label="选择分类"
							v-if="!item.rule_switch"
							:prop="'items.' + index + '.rule_list_value'"
							:rules="[{ required: true, message: '请选择规则分类', trigger: 'blur' }]"
						>
							<el-cascader
								v-model="item.rule_list_value"
								ref="ruleCascader"
								:popper-class="'ruleClass'"
								:options="rule_list"
								@change="ruleChange"
								:props="{ children: 'child', label: 'name', value: 'id', checkStrictly: true }"
							></el-cascader>
						</el-form-item>

						<el-form-item
							label="选择规则"
							v-if="item.rule_switch"
							:prop="'items.' + index + '.rule_item_list_value'"
							:rules="[{ required: true, message: '请选择规则', trigger: 'blur' }]"
						>
							<el-cascader
								v-model="item.rule_item_list_value"
								ref="ruleItem"
								:popper-class="'itemClass'"
								:options="rule_item_list"
								@change="ruleItemChange"
								:show-all-levels="false"
								:props="{ children: 'child', label: 'name', value: 'id' }"
							></el-cascader>
						</el-form-item>

						<el-form-item>
							<div v-show="item.rule_item_details.range_type == 1">{{ get_point_name(ptid) }} {{ item.rule_item_details.min_point }}</div>
							<div v-show="item.rule_item_details.range_type == 2">
								{{ get_point_name(ptid) }} {{ item.rule_item_details.min_point }} ~ {{ item.rule_item_details.max_point }}
							</div>
							<div>{{ item.rule_item_details.name }}</div>
						</el-form-item>
						<el-form-item label="积分" :prop="'items.' + index + '.point'" :rules="[{ required: true, message: '请输入分值', trigger: 'blur' }]">
							<el-input-number v-if="item.rule_item_details.range_type == 2" :min="item.min" :max="item.max" v-model="item.point" type="number"></el-input-number>
							<el-input-number v-else :disabled="item.rule_item_details.range_type == 1" v-model="item.point" type="number"></el-input-number>
						</el-form-item>

						<el-form-item label="发生时间" :prop="'items.' + index + '.event_time'" :rules="[{ required: true, message: '请选择时间', trigger: 'blur' }]">
							<el-row>
								<el-col :span="18">
									<el-date-picker v-model="item.event_time" type="date" placeholder="请选择时间" value-format="yyyy-MM-dd"></el-date-picker>
								</el-col>
							</el-row>
						</el-form-item>

						<el-form-item
							label="事件内容"
							:prop="'items.' + index + '.remark'"
							:rules="[{ required: true, message: '请输入事件内容', trigger: 'blur' }, { min: 3, max: 100, message: '长度在 3 到 100 个字符', trigger: 'blur' }]"
						>
							<el-row>
								<el-col :span="18"><el-input type="textarea" rows="6" placeholder="请输入事件内容" style="width: 100%;" v-model="item.remark"></el-input></el-col>
							</el-row>
						</el-form-item>

						<el-form-item label="图片">
<!-- 							<uploadOss
							  :headers="Xtoken"
							  class="avatar-uploader"
							  :action="'https://'+'integralsys.oss-cn-shenzhen.aliyuncs.com'"
							  :show-file-list="true"
							  :file-list="item.fileList"
							  :on-success="handleFilesSuccess"
							  :on-preview="onFilePreView"
							  :before-upload="beforeUpload"
							  :on-remove="onFileRemove"
							  :limit="3"
							  :multiple="true"
							  ref="clearPicture"
							>
							  <el-button size="small" type="primary" >点击上传</el-button>（最多选择3张）
							</uploadOss> -->
						</el-form-item>
						<el-form-item label="递交审批">
							<el-row>
								<el-col :span="18">
									<el-input auto-complete="off" v-model="item.approvalName" placeholder="请选择审批人"></el-input>
									<div @click="item.show_approval_selector = true" style=" position: absolute; top: 0; right: 0; left: 0; bottom: 0; z-index: 9;"></div>
								</el-col>
							</el-row>
							<EmployeeSelector
								:employee_not_select="item.approval_not_select"
								:can_select_employee="true"
								:can_select_dept="false"
								:multi="false"
								:employee_list="employee_lists"
								:selected="item.approval_selected"
								:visible.sync="item.show_approval_selector"
								@confirm="approval_confirm"
							/>
						</el-form-item>
					</div>
					<el-form-item style="margin-bottom: 0;"><div>如需录入多条，请点击“增加一条”</div></el-form-item>
					<el-form-item style="margin-bottom: 0;"><el-button type="primary" plain @click="addItem">+ 增加一条</el-button></el-form-item>
					<el-form-item style="text-align: right; margin-bottom: 0;">
						<el-button @click="closeDialog('dialogData')" :disabled="btn_loading">取 消</el-button>
						<el-button type="primary" @click="subData('dialogData')" :disabled="btn_loading">确 认</el-button>
					</el-form-item>
				</el-form>
			</div>
		</el-dialog>

		<el-dialog :title="'提交结果'" :visible.sync="error_list_show" :append-to-body="true" @close="error_list_SX" width="700px">
			<el-table :data="error_list">
				<el-table-column prop="target" label="员工"></el-table-column>
				<el-table-column prop="point" label="积分"></el-table-column>
				<el-table-column prop="status" label="处理状态">
					<template slot-scope="scope">
						<span :style="'color:' + (scope.row.status == 0 ? '#f70000' : '#47bf47')">{{ scope.row.status == 0 ? '提交失败' : '提交成功' }}</span>
					</template>
				</el-table-column>
				<el-table-column prop="msg" label="备注信息"></el-table-column>
			</el-table>
		</el-dialog>
	</div>
</template>

<script>
import moment from 'moment';
import EmployeeSelector from '@/components/EmployeeSelector.vue';
// import uploadOss from "@/views/upload_oss/upload"

export default {
	name: 'bonusPointsForm',
	// 数据
	model: {
		prop: 'list',
		event: 'value'
	},
	props: {
		title: {
			type: String,
			default: ''
		},
		visible: {
			type: Boolean,
			default: false
		},
		refresh: {
			type: String,
			default: ''
		},
		integralType: {
			type: Number,
			default: 0
			// 1 是绩效分 ， 2 是A分 , 3 是B分
		}
	},
	data() {
		return {
			// imageState:'',
			error_list: [], //错误信息数组
			error_list_show: false, //错误信息弹窗
			Xtoken: { 'X-Token': this.$getToken() },
			btn_loading: false,
			loading: false,
			dialogData: {
				members: [],
				items: [
					{
						rule_switch: true,
						rule_id: '',
						item_id: '',
						point: '0',
						remark: '',
						event_time: moment().format('YYYY-MM-DD'),
						approval: '',
						approval_not_select: [],
						pt_id: this.integralType,
						// 积分填写限制
						pointShow: 1,
						max: 0,
						min: 0,

						// 审批人信息
						reviewer_id: '',
						approvalName: '',
						approval_not_select: [],
						approval_selected: { dept: [], employee: [] },
						show_approval_selector: false,

						// 附件
						fileList: [],
						files: [],
						// 规则分类 与 规则细则 名称
						rule_list_value: null,
						rule_item_list_value: null,
						// 规则细则详情
						rule_item_details: { range_type: '' }
					}
				]
			},
			// 录入对象名称
			employeeName: '',
			employee_not_select: [],
			employee_selected: { dept: [], employee: [] },
			employee_list: [],
			employee_lists: [],
			show_employee_selector: false,
			// 规则分类
			rule_list: [],
			// 规则细则
			rule_item_list: [],
			flatteningIntegralRules: null,
			ptid: 0,
			point_types: JSON.parse(localStorage.getItem('SET_POINT_TYPES')),
			itemIndex: 0
		};
	},
	components: { EmployeeSelector },
	watch: {
		integralType(val) {
			this.dialogData.items[0].pt_id = val;
			this.ptid = val;
			// this.getRuleData();
			// this.getRuleItemData();
		},
		'dialogData.members'(val) {
			if (val.length == 0) {
				this.employeeName = '';
				this.employee_selected = { dept: [], employee: [] };
			}
		}
	},
	mounted() {
		// this.point_types = JSON.parse(localStorage.getItem('SET_POINT_TYPES'));
		// this.employee_list = this.$store.getters.user_info.employee_detail.manage_scope;
		// this.employee_lists = this.$store.getters.user_info.employee_detail.superior_list;
	},
	methods: {
		// 20200831 图片上传 未完成
		// 附件上传
		beforeUpload(file) {
			const isJPG = /^image\/(jpeg|png|jpg)$/.test(file.type);
			const isLt2M = file.size / 1024 / 1024 < 1;
			if (!isJPG) {
				this.$message.error('上传头像图片只能是 JPG 格式!');
			}
			if (!isLt2M) {
				this.$message.error('上传头像图片大小不能超过 2MB!');
			}
			return isJPG && isLt2M;
		},
		onFilePreView(file) {
			window.open(file.response.url, '_blank');
		},
		onFileRemove(file, fileList) {
			this.dialogData.items[this.itemIndex].fileList = fileList;
			this.dialogData.items[this.itemIndex].files = [];
			fileList.forEach((element, index) => {
				this.dialogData.items[this.itemIndex].files.push(element.url);
			});
		},
		handleFilesSuccess(response, file, fileList) {
			// this.imageState = '上传成功'
			this.dialogData.items[this.itemIndex].fileList = fileList;
			this.dialogData.items[this.itemIndex].files = [];
			fileList.forEach((element, index) => {
				this.dialogData.items[this.itemIndex].files.push(element.url);
			});
		},
		// 图片上传

		// 没有人员提示
		noPersonnelListTips() {
			this.$message.error('您没有管理范围，请联系管理员');
		},
		// 当switch 改变了
		switchChange(index, value) {
			this.itemIndex = index;
			const item = this.dialogData.items[this.itemIndex];
			if (!value) {
				item.rule_id = '';
				item.item_id = '';
				item.rule_item_list_value = '';
				item.rule_item_details = { range_type: '' };
			} else {
				item.rule_id = '';
				item.rule_list_value = '';
			}
		},
		// 选择录入对象
		move_employee_confirm(data) {
			this.employee_selected = { dept: [], employee: [] };
			this.employeeName = '';
			this.dialogData.members = [];
			if (data.employee !== null && data.employee.length != 0) {
				let nameArr = [];
				data.employee.forEach(element => {
					this.employeeName += element.name + ',';
					this.employee_selected = data;
					this.dialogData.members.push(element.id);
				});
			}
		},
		// 获取规则信息
		getRuleData() {
			let data = {
				cycle_type: '1',
				pt_id: 2
			};
			this.integralType === 1 ? (data.pt_id = '1') : this.integralType === 2 ? (data.pt_id = '2') : (data.pt_id = '3');
			this.$axios('get', '/api/integral/rule/trees', data).then(res => {
					if (res.data.code == 1) {
						const resultData = res.data.data;
						this.rule_list = resultData.rule_tree;
					}
					this.rule_list = this.getTreeData(this.rule_list);
				})
				.catch(e => {
					this.$message.error(e.data.msg);
				});
		},
		// 获取规则细则
		getRuleItemData() {
			let data = {
				cycle_type: '1',
				pt_id: '1'
			};
			this.loading = true;
			this.integralType === 1 ? (data.pt_id = '1') : this.integralType === 2 ? (data.pt_id = '2') : (data.pt_id = '3');
			// const headers = {'Accept':'application/vnd.test.v2+json'}
			this.$axios('get', '/api/integral/rule/trees', data, 'v2').then(res => {
					if (res.data.code == 1) {
						const resultData = res.data.data;
						this.rule_item_list = resultData.tree;
						this.flatteningIntegralRules = this.getItemDetail(this.rule_item_list);
						this.loading = false;
					}
				})
				.catch(e => {
					this.$message.error(e.data.msg);
				});
		},
		// 规则细则变化关闭down
		ruleItemChange(value) {
			let ruleItemDetails = null;
			this.flatteningIntegralRules.forEach(element => {
				if (element.id == value[value.length - 1]) {
					ruleItemDetails = { ...element };
				}
			});
			const item = this.dialogData.items[this.itemIndex];
			const user_info = this.$store.getters.user_info;
			item.rule_item_details = ruleItemDetails;
			item.remark = ruleItemDetails.name;
			item.rule_id = ruleItemDetails.pid;
			item.item_id = value[value.length - 1];
			item.max = ruleItemDetails.max_point * 1;
			item.min = ruleItemDetails.min_point * 1;
			item.point = ruleItemDetails.min_point;
		},
		// 规则分类变化关闭dewn
		ruleChange(value) {
			const item = this.dialogData.items[this.itemIndex];
			const user_info = this.$store.getters.user_info;
			user_info.point_config.point_limit.forEach(element => {
				if (this.ptid == this.integralType) {
					item.max = element.point * 1;
					item.min = element.point * -1;
				}
			});
			this.$refs.ruleCascader.forEach(element => {
				element.dropDownVisible = false;
			});
			item.rule_id = value[value.length - 1];
		},
		// 递归判断列表，把最后的child设为undefined
		getTreeData(data) {
			for (var i = 0; i < data.length; i++) {
				if (data[i].child.length < 1) {
					// child若为空数组，则将child设为undefined
					data[i].child = undefined;
				} else {
					// child若不为空数组，则继续 递归调用 本方法
					this.getTreeData(data[i].child);
				}
			}
			return data;
		},

		getItemDetail(arr) {
			let result = [];
			for (const item of arr) {
				var res = JSON.parse(JSON.stringify(item)); // 先克隆一份数据作为第一层级的填充
				delete res['child'];
				result.push(res);
				if (item.child instanceof Array && item.child.length > 0) {
					// 如果当前child为数组并且长度大于0，才可进入getItemDetail()方法
					result = result.concat(this.getItemDetail(item.child));
				}
			}
			return result;
		},
		// 加一条
		addItem() {
			this.dialogData.items.push({
				rule_switch: true,
				rule_id: '',
				item_id: '',
				point: '0',
				remark: '',
				event_time: moment().format('YYYY-MM-DD'),
				approval: '',
				approval_not_select: [],
				pt_id: this.integralType,

				// 积分填写限制
				pointShow: 1,
				max: 0,
				min: 0,

				// 审批人信息
				reviewer_id: '',
				approvalName: '',
				approval_not_select: [],
				approval_selected: { dept: [], employee: [] },
				show_approval_selector: false,

				// 附件
				fileList: [],
				files: [],

				// 规则分类 与 规则细则 名称
				rule_list_value: null,
				rule_item_list_value: null,

				// 规则细则详情
				rule_item_details: { range_type: '' }
			});
		},
		closeDialog(formName) {
			this.dialogData.items.forEach(element => {
				element.rule_item_details = { range_type: '' };
			});
			this.$refs[formName].resetFields();
			this.closePopup();
			// this.$emit('update:visible', false)
		},
		delItem(index) {
			this.$confirm('你确定要删除奖扣明细' + parseInt(index + 1) + '吗?', '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			})
				.then(() => {
					this.dialogData.items.splice(index, 1);
					this.$message({
						type: 'success',
						message: '删除成功!'
					});
				})
				.catch(() => {});
		},
		subData(formName) {
			this.$refs[formName].validate(valid => {
				if (valid) {
					this.btn_loading = true;
					this.save();
				}
			});
		},
		// 提交数据
		save() {
			let data = {
				members: this.dialogData.members,
				items: []
			};
			const user_info = this.$store.getters.user_info;
			const index = user_info.point_config.point_limit.findIndex(o => o.pt_id === this.integralType);
			console.log(this.dialogData);
			let employeePointLimitMin = null;
			let employeePointLimitMax = null;
			user_info.point_config.point_limit.forEach(element => {
				if (this.ptid == this.integralType) {
					employeePointLimitMax = element.point * 1;
					employeePointLimitMin = element.point * 1;
				}
			});
			const ruleLimitCheck = user_info.site_config.rule_limit_check;
			let maxPointPermission = 0;
			let creator = this.$store.getters.user_info.employee_detail.role_list.findIndex(item => item.name == 'creator') >= 0;
			if (user_info.point_config.point_limit.length > 0) {
				maxPointPermission = parseInt(user_info.point_config.point_limit[index].point);
			} else {
				if (creator) {
					maxPointPermission = -1;
				}
			}
			// 手机端逻辑
			//  || (user_info.is_creator !== 1 && maxPointPermission == 0)
			try {
				if (index < 0 || user_info.is_creator === 1) {
					this.dialogData.items.forEach((element, i) => {
						data.items.push({
							rule_id: element.rule_id || 0,
							item_id: element.item_id || 0,
							point: element.point,
							remark: element.remark,
							event_time: element.event_time,
							pt_id: this.ptid,
							reviewer_id: element.reviewer_id || 0,
							files: element.files
						});
					});
				}
				else {
					this.dialogData.items.forEach((element, index) => {
						!element.reviewer_id ? (element.reviewer_id = 0) : '';
						!element.item_id ? (element.item_id = 0) : '';
						if (
							(element.reviewer_id && element.point !== 0 && element.rule_id > 0) ||
							(element.reviewer_id <= 0 &&
								element.item_id > 0 &&
								ruleLimitCheck &&
								element.point !== 0 &&
								element.point <= maxPointPermission &&
								Math.abs(element.point) <= maxPointPermission) ||
							(element.reviewer_id <= 0 && !ruleLimitCheck && this.integralType == 3 && element.rule_id > 0) ||
							(element.reviewer_id <= 0 &&
								element.item_id >= 0 &&
								element.point !== 0 &&
								element.point <= maxPointPermission &&
								Math.abs(element.point) <= maxPointPermission &&
								element.rule_id > 0)
						) {
							data.items.push({
								rule_id: element.rule_id || 0,
								item_id: element.item_id || 0,
								point: element.point,
								remark: element.remark,
								event_time: element.event_time,
								pt_id: this.ptid,
								reviewer_id: element.reviewer_id || 0,
								files: element.files
							});
						} else {
							this.$message.error('第' + (index + 1) + '条输入积分分值超出权限，请选择审批人递交');
							throw new Error();
						}
					});
				}
			} catch (e) {
				this.btn_loading = false;
				return false;
			}
			this.$axios('post', this.integralType === 1 ? '' : this.integralType === 2 ? '/api/integral/review/a/entry' : '/api/integral/point/entry', data).then(res => {
					if (res.data.code == 1) {
						this.dialogData.items.forEach(element => {
							element.rule_item_details = { range_type: '' };
						});
						this.$refs['dialogData'].resetFields();
						this.$emit('update:visible', false);
						this.$emit('update:refresh',this.$moment().format().valueOf());
						this.$message.success(res.data.msg);
						this.closePopup();
						this.error_list = res.data.data.list;
						this.error_list_show = true;
					} else {
						this.$message.error(res.data.msg);
					}
				})
				.catch(e => {
					this.$message.close();
				});
			this.$nextTick(() => {
				this.btn_loading = false;
			});
		},
		//关闭错误信息时的回调
		error_list_SX() {
			// this.loadBaseData();
			// this.loadEmployeeList()
		},
		// 选择审核人
		approval_confirm(data) {
			const item = this.dialogData.items[this.itemIndex];
			item.approvalName = '';
			item.approval_selected.employee = { dept: [], employee: [] };
			item.reviewer_id = '';
			if (data.employee !== null && data.employee.length != 0) {
				item.approvalName = data.employee[0].name;
				item.approval_selected.employee = [{ name: data.employee[0].name, id: data.employee[0].id, img_url: data.employee[0].img_url }];
				item.reviewer_id = data.employee[0].id;
			}
			item.reviewer_id ? (item.pointShow = 3) : '';
		},
		// 获取积分名称
		get_point_name(id) {
			// let name = '';
			// this.point_types.forEach(element => {
			// 	if (element.id == id) {
			// 		name = element.name;
			// 	}
			// });
			// return name;
		},
		// 关闭弹窗
		closePopup() {
			//关闭重置窗口状态
			this.dialogData.items = [
				{
					rule_switch: true,
					rule_id: '',
					item_id: '',
					point: '0',
					remark: '',
					event_time: moment().format('YYYY-MM-DD'),
					approval: '',
					approval_not_select: [],
					pt_id: this.integralType,
					// 积分填写限制
					pointShow: 1,
					max: 0,
					min: 0,
					// 审批人信息
					reviewer_id: '',
					approvalName: '',
					approval_not_select: [],
					approval_selected: { dept: [], employee: [] },
					show_approval_selector: false,
					// 附件
					fileList: [],
					files: [],
					// 规则分类 与 规则细则 名称
					rule_list_value: null,
					rule_item_list_value: null,
					// 规则细则详情
					rule_item_details: { range_type: '' }
				}
			];
			this.$emit('update:visible', false);
		}
	}
};
</script>
<style lang="scss">
	.itemClass .el-cascader-menu .el-cascader-menu__wrap .el-scrollbar__view li.el-cascader-node {
		height: auto;
		max-width: 500px;
		.el-cascader-node__label {
			white-space: initial;
			overflow: initial;
			text-overflow: initial;
		}
	}
</style>
